from flask import Flask, request
from twilio.twiml.messaging_response import Body, Message, Redirect, MessagingResponse

app = Flask(__name__)

#@app.route("/wa")
#def hello():
#    return "Hello WahtsApp World!"


@app.route("/wa", methods=['POST', 'GET'])
def wa_ahoy_reply():
    """Respond to incoming messages with a friendly WA."""
    # Start our response

    body = request.values.get('Body', None)

    resp = MessagingResponse()
    resp.message("Ahoy! Thanks so much for your message. Lala" + body)

    return str(resp)

if __name__ == "__main__":
    app.run(debug=True)

